using System;
using System.Threading;

namespace PrikladyZive51
{
	/// <summary>
	/// Ukazka mozneho zpusobeni blokace zamku metodou Pulse.
	/// Spusteni tohoto prikladu zpusobi, ze program neskonci.
	/// </summary>
	internal class PulsingWithDeadlockExam
	{
		internal static void Run()
		{
			Thread.CurrentThread.Name = "Prvni vlakno";
			PulsingWithDeadlockExam lInstance = new PulsingWithDeadlockExam();
			Thread lSecond = new Thread(new ThreadStart( lInstance.DoSomeWork));
			lSecond.Name = "Druhe vlakno";
			lSecond.Start();
			lInstance.DoSomeWork();
		}
		
		internal void DoSomeWork()
		{
			lock(this)
			{
				for (int i = 0; i < 3; i++)
				{
					Console.WriteLine("{0} - {1}", Thread.CurrentThread.Name, i);
					//probuzeni dalsiho vlakna
					Monitor.Pulse(this);
					//vzdani se zamku k objektu
					Monitor.Wait(this);
				}
				Console.WriteLine("Vlakno {0} skoncilo svou cinnost", Thread.CurrentThread.Name);
			}
		}
	}
}
